import 'dart:async';
import 'dart:convert';

import 'package:flutter/services.dart';
import 'package:hls_player/model/video.dart';
import 'package:meta/meta.dart';

class HlsPlayer {
  static const MethodChannel _channel = const MethodChannel('hls_player');

  static Future<String> initializeVideo(
      {@Required('url parameter required') String url}) async {
    final String urlEnviada = await _channel.invokeMethod(
      'initializeVideo',
      <String, String>{'url': url},
    );
    return urlEnviada;
  }

  static Future<String> initializeZapping(
      {@Required('canales parameter required') List<Video> canales,
      @Required('playVideoAtIndex parameter required') int playVideoAtIndex,
      @Required('isSearchingItem parameter required') bool isSearchingItem,
      @Required('urlEPG parameter required') String urlEPG}) async {
    final canalesEnviados = await _channel.invokeMethod(
      'initializeZapping',
      <String, dynamic>{
        'canales': json.encode(canales),
        'playVideoAtIndex': playVideoAtIndex,
        'isSearchingItem': isSearchingItem,
        'urlEPG': urlEPG,
      },
    );
    return canalesEnviados;
  }

  static Future<String> getVideoLink() async {
    final canalesEnviados = await _channel.invokeMethod(
      'getVideoLink',
    );
    return canalesEnviados;
  }
}
